/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package samplemssp;

import java.io.IOException;
import java.net.MalformedURLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.bind.DatatypeConverter;
import javax.xml.rpc.ServiceException;
import org.apache.axis.types.URI;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import vgca.mssp.ExtSignature;
import vgca.mssp.JvmSsl;
import vgca.mssp.VerificationCodeCalculator;

/**
 *
 * @author thaopc
 */
public class Samplemssp {

    private static final Log log = LogFactory.getLog(Samplemssp.class);
    
   
    public static void signHashTest() throws URI.MalformedURIException, ServiceException, MalformedURLException{
        
        //Khi thực hiện ký số PDF:
        //1. Ví dụ Giá trị SHA256 của file PDF cần ký số tính toán được như sau:
        //byte[] hashData = DatatypeConverter.parseHexBinary("c775e7b757ede630cd0aa1113bd102661ab38829ca52a6422ab782862f268646");
        
        //2. Đóng gói giá trị hashData thành DigestInfo:
        //AlgorithmIdentifier sha256Aid = new AlgorithmIdentifier(NISTObjectIdentifiers.id_sha256, DERNull.INSTANCE);
        //DigestInfo di = new DigestInfo(sha256Aid, hashData);
        //byte[] message = digestInfo.getEncoded(ASN1Encoding.DER);
        //Giả sử message có giá trị như dưới đây:
        byte[] message = DatatypeConverter.parseHexBinary("3021300906052B0E03021A0500041492902E74284AC4060C83C5EC6805C9C4BD89FA83");
        
        //Dưới đây là thông tin truststore (CTS CA) và CTS AP để kết nối MSSP
        String TRUSTSTORE_FILE = "etc/truststore-bcy.jks";
        String TRUSTSTORE_PASSWORD = "changeit";
        String KEYSTORE_FILE = "etc/3108937_VGCA_Application_Provider_certificate.p12";
        String KEYSTORE_PASSWORD = "123456";
        String KEYSTORE_TYPE = "PKCS12";
        
        // Đây là thông tin ID của AP để truy cập dịch vụ MSSP
        String AP_ID = "http://ap.mobile-id.vn/viettelca";
        String AP_PASSWORD = "12345678";
        
        //Thiết lập giao thức SSL
        log.info("setting up ssl");
        JvmSsl.setSSL(TRUSTSTORE_FILE, TRUSTSTORE_PASSWORD,
                        KEYSTORE_FILE, KEYSTORE_PASSWORD, KEYSTORE_TYPE);
        
        //So dien thoai SIM-PKI
	String msisdn = "84972495193";
        
        
        //3. Tính toán mã xác thực để hiển thị trên giao diện app cho người dùng xem,
        //và so sánh với giá trị VC hiện trên giao diện xác nhận giao dịch ký số.
	String vc = VerificationCodeCalculator.calculate(message);
        log.info("VC: "+vc);
        
        //4. Đây là chuỗi thông báo sẽ hiển thị trên điện thoại lắp SIM ký số, VC là mã xác thực giao dịch, mã này phải khớp với mã xác thực tính toán ở bước 3.
        String dataToBeDisplayed = "Ma giao dich %%VC%%. Vui long xac nhan giao dich";
        
        byte[] signature = null;
        //5. Thực hiện ký số trên SIM-PKI
        ExtSignature signer = new ExtSignature();
        signer.setAPID(AP_ID);
        signer.setAPPWD(AP_PASSWORD);
        try {
            //Test getCert
            //byte[] certBytes = signer.GetCert(msisdn);

            signature = signer.sign(message, msisdn, dataToBeDisplayed);
        } catch (IOException ex) {
            Logger.getLogger(Samplemssp.class.getName()).log(Level.SEVERE, null, ex);
        }
        
	log.info("got resp");
        long statusCode = signer.getStatusCode();
        log.info("statuscode " + statusCode);
        System.out.println("MSSP TransId: "+ signer.getTransID());
        log.info("signature  "
                        + DatatypeConverter.printBase64Binary(signature));
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try{
            signHashTest();
        }catch(Exception ex){
            System.out.println("object: "
                                + ex.getMessage());
        }
    }
    
}
